from FatxFast import game
from FatxFast.scenes import scenemanager
from FatxFast.scenes import gamescene
from FatxFast.scenes import menuscenes
import pygame
from nose.tools import *

class TestManager(object):
    
    def setup(self):
        self.game = game.Game()
        self.manager = scenemanager.SceneManager(self.game)

    def test_change_scene(self):
        previous_scene = self.manager.scenes[-1]
        self.manager.change_scene(gamescene.GameScene(self.manager))
        assert_is_not(previous_scene, self.manager.scenes[-1])

    def test_change_scene_to_gamescene(self):
        self.manager.change_scene(gamescene.GameScene(self.manager))
        assert_equal(self.manager.scenes[-1].playing, True)

    def test_loading_game(self):
        self.manager.push_scene_by_name("gamescene")
        assert_is_instance(self.manager.scenes[-1], gamescene.GameScene)

    def test_resuming_game(self):
        self.manager.change_scene(gamescene.GameScene(self.manager))
        self.manager.push_scene(menuscenes.SaveScene(self.manager))
        self.manager.pop_scene()
        assert_not_equal(self.manager.scenes[-1].paused, True)

    def test_pop_scene(self):
        scene_count = len(self.manager.scenes)
        self.manager.pop_scene()
        assert_less(len(self.manager.scenes), scene_count)
 
